<%-- $Id: auto_install.jsp 4476 2008-09-05 15:14:42Z jari $
	------------------------------------------------------------------
	Copyright (C) 2007 Johan Enell, Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330,
	Boston, MA  02111-1307, USA.
	------------------------------------------------------------------


	@author Martin
	@version 2.5
--%>
<%@ page session="false"

	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.ItemNotFoundException"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.PluginConfiguration"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Expressions"
	import="net.sf.basedb.util.FileUtil"
	import="net.sf.basedb.util.RegexpFileFilter"
	import="net.sf.basedb.util.JarClassLoader"
	import="net.sf.basedb.util.PluginInfo"
	import="net.sf.basedb.util.PluginConfigInfo"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.clients.web.Base"
	
	import="java.util.Collections"
	import="java.util.List"
	import="java.util.LinkedList"
	import="java.util.Iterator"
	import="java.io.FileFilter"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%!
private String getInfoMessage(PluginInfo info, int id)
{
	StringBuilder message = new StringBuilder();
	message.append("<div id=\"info."+id+"\" class=\"postit\" style=\"width:350px;display:none;\">");
	
	message.append("<b>").append("Jar: ").append("</b>");
	String jarpath = info.getJarPath();
	message.append(jarpath.substring(jarpath.lastIndexOf('/')+1)).append("<br>");
	
	message.append("<b>").append("Class: ").append("</b>");
	message.append(HTML.encodeTags(info.getClassName())).append("<br>");
	
	message.append("<b>").append("Version: ").append("</b>");
	message.append(HTML.encodeTags(info.getAbout().getVersion())).append("<br>");
	
	message.append("<b>").append("Works with: ").append("</b>");
	message.append("BASE ").append(info.getMinBaseVersion()).append(" and higher").append("<br>");
	
	message.append("<b>").append("Description: ").append("</b>");
	message.append(HTML.encodeTags(info.getAbout().getDescription())).append("<br>");
	message.append("</div>");
	return message.toString();
}
%>
<%
final Item itemType = Item.PLUGINDEFINITION;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();

try
{
	String title = "Plugin autoinstaller";
	String tt = cc.getPropertyValue("trusted");
	String up = cc.getPropertyValue("usePermissions");
	String aie = cc.getPropertyValue("allowImmediateExection");
	boolean isTrusted = tt == null ? true : Values.getBoolean(tt);
	boolean usePermissions = up == null ? false : Values.getBoolean(up);
	Boolean allowImmediateExecution = aie == null ? null : Values.getBoolean(aie);
	
	java.io.File pluginDir = new java.io.File(request.getParameter("plugin_path"));
	List<PluginInfo> pluginInfos = new LinkedList<PluginInfo>();
	FileFilter jarFilter = new RegexpFileFilter(".*\\.jar", null);
	List<java.io.File> jarFiles = FileUtil.findFiles(pluginDir, jarFilter);
		
	for (java.io.File file : jarFiles)
	{
		pluginInfos.addAll(PluginInfo.loadFromJar(file));
	}
	%>
	<base:page type="popup" title="<%=title%>">
	<base:head scripts="tabcontrol.js" styles="tabcontrol.css">
		<script language="JavaScript">
		
		// Submit the form
		function saveSettings(install)
		{
			var frm = document.forms['autoinstall'];
			frm.submit();
		}
		function toggle(grpId)
		{
			var grp = document.getElementById('grp.'+grpId);
			var grpIcon = document.getElementById('grp.'+grpId+'.icon');
			var anchor = document.getElementById('a.'+grpId);
			var cnfId = 1;
			var cnf = document.getElementById('cnf.'+grpId+'.'+cnfId);
			if (cnf && cnf.style.display == 'none')
			{
				grpIcon.src = getRoot()+'images/joust/minustop.gif';
				anchor.title='Collapse to hide configurations';
			}
			else
			{
				grpIcon.src = getRoot()+'images/joust/plusonly.gif';
				anchor.title='Expand to see configurations for this plugin';				
			}
			while (cnf)
			{
				Main.showHide(cnf.id);
				cnfId++;
				cnf = document.getElementById('cnf.'+grpId+'.'+cnfId);
			}
		}
		function setConfigsOnChange(pluginId, selectList, pluginExists)
		{
			var installoption = selectList[selectList.selectedIndex].value;
			if (installoption == 'plugin+confs')
			{
				var cnfId = 1;
				var cnf = document.getElementById('setconfig.'+pluginId+'.'+cnfId);
				while (cnf)
				{
					for (var i = 0; i < cnf.length; i++)
					{
						
						if (cnf[i].value == '1')
						{
							cnf.selectedIndex = i;
							i = cnf.length;													
						}
					}
					cnfId++;
					cnf = document.getElementById('setconfig.'+pluginId+'.'+cnfId);
				}
			}
			else if (!pluginExists && installoption == '')
			{
				var cnfId = 1;
				var cnf = document.getElementById('setconfig.'+pluginId+'.'+cnfId);
				while (cnf)
				{
					for (var i = 0; i < cnf.length; i++)
					{
						
						if (cnf[i].value == '0')
						{
							cnf.selectedIndex = i;
							i = cnf.length;													
						}
					}
					cnfId++;
					cnf = document.getElementById('setconfig.'+pluginId+'.'+cnfId);
				}
			}
		}
		function setPluginOnChange(pluginId, selectList, pluginExists)
		{
			var configOption = selectList[selectList.selectedIndex].value;
			var pluginList = document.getElementById('setplugin.' + pluginId);
			var pluginOption = pluginList[pluginList.selectedIndex].value;
			if ( (configOption == '1' && !pluginExists && pluginOption == '') ||
				(configOption == '0' && pluginOption == 'plugin+confs') )
			{
				for (var i=0; i<pluginList.length;i++)
				{
					if (pluginList[i].value == 'plugin')
					{
						pluginList.selectedIndex = i;
						i = pluginList.length;
					}
				}
			}
		}
		function toggleInformation(pluginId)
		{
			var infodiv = document.getElementById('info.'+pluginId);
			if (infodiv.style.display == 'block')
			{
				infodiv.style.display = 'none';				
			}
			else if (infodiv.style.display == 'none')
			{
				infodiv.style.display = 'block';
			}
		}
		</script>
	</base:head>
	<base:body>
		<form name="autoinstall" action="index.jsp" method="post" onsubmit="return false;">
		<input type="hidden" name="ID" value="<%=ID%>">
		<input type="hidden" name="cmd" value="LoadPlugins">
		<input type="hidden" name="plugin_path" value="<%=pluginDir%>">
		
		<h3 class="docked"><%=title%> <base:help tabcontrol="plugins" /></h3>
		
		<t:tabcontrol id="plugins" contentstyle="<%="height: "+(int)(scale*260)+"px;"%>" 
			position="bottom">
			<t:tab id="plugins" title="Available plugins" validate="validatePlugins()" helpid="plugindefinition.autoinstaller">
				<div align="left">
					<table border="0" cellspacing="0" cellpadding="0">
						<tr>
							<td width="45%"><b>Plugins</b></td>							
							<td><b>Install</b></td>
							<td><b>Trusted</b></td>
							<td><b>Immediate execution</b></td>
						</tr>
						<%
						int plugin = 0;
						for (PluginInfo info : pluginInfos)
						{
							String name = info.getAbout().getName();
							List<PluginConfigInfo> cnfInfos = info.getConfigurations();
							++plugin;
							int cnf = 0;
							boolean hasConfigs = cnfInfos != null && !cnfInfos.isEmpty();
							boolean classExists = true;
							boolean jarExists = false;
							PluginDefinition pd = null;
							try
							{
								pd = PluginDefinition.getByClassName(dc, info.getClassName());
								if (pd.getJarPath().equals(info.getJarPath()))
								{
									jarExists = true;
								}
							}
							catch(ItemNotFoundException ex)
							{
								classExists = false;
								jarExists = false;
							}							
							%>
							<tr id="plugin.<%=plugin%>">
								<td style="padding-top: 6px;">									
									<%
									if (hasConfigs)
									{
									%>
										<a href="javascript:toggle(<%=plugin%>)" id="<%="a."+plugin%>" title="Expand to see configurations for this plugin">
										<base:icon id="<%="grp."+plugin+".icon"%>" image="joust/plusonly.gif" />
										<a onmouseover="javascript:toggleInformation(<%=plugin%>)" 
											onmouseout="javascript:toggleInformation(<%=plugin%>)"
										>
											<base:icon image="info.gif"/>
										</a>									
										<%=getInfoMessage(info, plugin)%>
										&nbsp;<%=HTML.encodeTags(name)%></a>&nbsp;&nbsp;										
										<%
									}
									else
									{
										%>
										<a onmouseover="javascript:toggleInformation(<%=plugin%>)" 
											onmouseout="javascript:toggleInformation(<%=plugin%>)"
										>
											<base:icon image="info.gif"/>
										</a>									
										<%=getInfoMessage(info, plugin)%>
										&nbsp;<%=HTML.encodeTags(name)%>&nbsp;&nbsp;
										<%
									}
									%>									
									
								</td>
								<td>
									<select id="setplugin.<%=plugin%>" name="<%=info.getJarPath()%>.<%=info.getClassName()%>" 
										style="width:90px"
									 	onchange="setConfigsOnChange(<%=plugin%>,this, <%=classExists%>)" 
									 	<%=classExists&&jarExists ? "disabled" : "" %>
									 >
										<option value="" title="Plugin will not be installed">no
										<%
										if (hasConfigs)
										{
											%>
											<option value="plugin" title="Only the plugin will be installed">plugin only
											<option value="plugin+confs" 
												title="Plugin and all configurations will be installed">plugin + configurations</option>
											<%
										}
										else
										{
											%>
											<option value="plugin" title="Plugin will be installed">yes
											<%
										}
										%>
									</select>&nbsp;&nbsp;
									<input type="hidden" name="<%=info.getClassName()%>.classExists" value="<%=classExists%>">
									<input type="hidden" name="<%=info.getClassName()%>.jarExists" value="<%=jarExists%>">
									<base:icon image="<%=classExists&&!jarExists ? "itemexists.gif" : "" %>" 
										tooltip="The plugin is loaded from a different jar-file"
									/>
									<base:icon image="<%=classExists&&jarExists ? "hasvalues.gif" : "" %>" 
										tooltip="Plugin with the same class name is already installed"
									/>
								</td>
								<td>
									&nbsp;
									<select name="<%=info.getClassName()%>.trusted" 
										<%=classExists&&jarExists ? "disabled" : ""%>
									>
										<option value="0">no
										<option value="1">yes
									</select>
									&nbsp;&nbsp;
								</td>
								<td>
									&nbsp;
									<select name="<%=info.getClassName()%>.immediate_execution" 
										<%=classExists&&jarExists ? "disabled" : ""%>
									>
										<option value="0">deny
										<option value="1">allow
										<%
										if (allowImmediateExecution == null)
										{
											%>
											<option value="" selected>auto
											<%
										}
										%>
									</select>
								</td>
							</tr>
							<%
							if (hasConfigs)
							{
								Iterator<PluginConfigInfo> cnfi = cnfInfos.iterator();
								while (cnfi.hasNext())
								{
									PluginConfigInfo cnfInfo = cnfi.next();
									boolean isDuplicate = false;
									if (classExists)
									{
										ItemQuery<PluginConfiguration> cnfQuery = pd.getPluginConfigurations();
										cnfQuery.include(Include.ALL);
										cnfQuery.restrict(Restrictions.eq(Hql.property("name"), Expressions.string(cnfInfo.getName())));
										Iterator<PluginConfiguration> it = cnfQuery.iterate(dc);
										isDuplicate = it != null && it.hasNext();
									}
									++cnf;
									boolean hasNext = cnfi.hasNext();
									%>
									<tr id="cnf.<%=plugin%>.<%=cnf%>" style="display: none;">
										<td>
											<base:icon 
												image="<%=hasNext ? "joust/big/join.gif" : "joust/big/joinbottom.gif"%>" 
											/>											
											<%=HTML.encodeTags(cnfInfo.getName())%>&nbsp;
										</td>
										<td>
											<select id="setconfig.<%=plugin%>.<%=cnf%>" name="<%=info.getClassName()%>.<%=cnfInfo.getName()%>"
												onChange="setPluginOnChange(<%=plugin%>, this, <%=classExists%>)">
												<option value="0" title="Configuration will not be imported">no</option>
												<option value="1" title="Configuration will be imported">yes</option>
											</select>
											<base:icon image="<%=isDuplicate ? "warning.gif" : ""%>" tooltip="Plugin already has a configuration with this name"/>
										</td>
									</tr>
									<%
								}
							}
						}
						%>
					</table>					
				</div>
				<div align="right">
					&nbsp;<i><base:icon image="warning.gif" /> = duplicate configuration</i><br>
					&nbsp;<i><base:icon image="hasvalues.gif" /> = plugin already installed</i><br>
					&nbsp;<i><base:icon image="itemexists.gif" /> = exists in a different jar-file,<br> 
						installing will change the jar path.</i><br>
				</div>
			</t:tab>
		
		</t:tabcontrol>
		
		<table align="center">
		<tr>
			<td width="50%"><base:button onclick="saveSettings()" title="Save" /></td>
			<td width="50%"><base:button onclick="window.close()" title="Cancel" /></td>
		</tr>
		</table>
	</base:body>	
	</base:page>
	<%	
}
finally
{
	if (dc != null) dc.close();
}
%>