<%-- $Id: restart.jsp 4476 2008-09-05 15:14:42Z jari $
	------------------------------------------------------------------
	Copyright (C) 2006 Jari Hakkinen, Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330,
	Boston, MA  02111-1307, USA.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Client"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.ClientDefaultSetting"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.clients.web.Base"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>

<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();

try
{
	final Client server = Client.getById(dc, sc.getClientId());
	final ClientDefaultSetting adminName = server.getDefaultSetting("server.admin.name");
	final ClientDefaultSetting adminEmail = server.getDefaultSetting("server.admin.email");
	final ClientDefaultSetting about = server.getDefaultSetting("server.about");
	final ClientDefaultSetting getAccount = server.getDefaultSetting("server.get.account");
	final ClientDefaultSetting forgottenPassword = server.getDefaultSetting("server.forgotten.password");
	final ClientDefaultSetting transferRate = server.getDefaultSetting("server.transferRate");

	final boolean writePermission = server.hasPermission(Permission.WRITE);
	final String clazz = writePermission ? "class=\"text\"" : "class=\"text disabled\" disabled readonly";
	%>
	<base:page type="popup" title="Server configuration">
	<base:head>
	<script language="JavaScript">
	function restartServer()
	{
		Main.hide('confirm');
		Main.show('restart');
		location.href = 'submit_server.jsp?ID=<%=ID%>&cmd=RestartServer';
	}
	</script>

	</base:head>
	<base:body >
	<div id="confirm">
		<base:note type="question" title="Restart BASE?">
			<br>
			Are you sure you want to restart the BASE server? 
			Unsaved data for all logged in users will be lost!
			<br><br>
		</base:note>
		<p>
		<table align="center">
		<tr>
			<td width="50%"><base:button onclick="restartServer()" title="Yes" /></td>
			<td width="50%"><base:button onclick="window.close()" title="No" /></td>
		</tr>
		</table>
	</div>
	
	<div id="logout" style="display: none;">
		<base:note type="info" title="Restarting BASE...">
		The server is now beeing restarted. Please wait.
		</base:note>
	</div>

	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>

