<%-- $Id: list_annotations.jsp 4476 2008-09-05 15:14:42Z jari $
	------------------------------------------------------------------
	Copyright (C) 2006 Jari Hakkinen, Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330,
	Boston, MA  02111-1307, USA.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.AnnotationType"
	import="net.sf.basedb.core.Protocol"
	import="net.sf.basedb.core.AnnotationSet"
	import="net.sf.basedb.core.Annotation"
	import="net.sf.basedb.core.Annotatable"
	import="net.sf.basedb.core.AnnotatableProxy"
	import="net.sf.basedb.core.Nameable"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.util.Values"
	import="java.util.List"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>

<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final Item itemType = Item.valueOf(request.getParameter("item_type"));
final int itemId = Values.getInt(request.getParameter("item_id"));
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();

try
{
	final Annotatable item = (Annotatable)itemType.getById(dc, itemId);
	ItemQuery<AnnotationType> annotationTypeQuery = null;
	String message = null;
	boolean isProxy = item instanceof AnnotatableProxy;

	if (isProxy)
	{
		AnnotatableProxy proxy = (AnnotatableProxy)item;
		annotationTypeQuery = Base.getAnnotationTypesQuery(proxy);
		message = proxy.getAnnotationMessage();
	}
	else
	{
		annotationTypeQuery = Base.getAnnotationTypesQuery(itemType, false);
	}
	final List<AnnotationType> annotationTypes = annotationTypeQuery.list(dc);
	Protocol protocol = null;
	boolean readProtocol = true;
	try
	{
		protocol = item.getProtocol();
	}
	catch (PermissionDeniedException ex)
	{
		readProtocol = false;
	}
	final List<AnnotationType> protocolParameters = protocol == null ? 
		null : Base.getProtocolParametersQuery(protocol).list(dc);
	final boolean writePermission = item.hasPermission(Permission.WRITE);

	final AnnotationSet as = item.isAnnotated() ? item.getAnnotationSet() : null;
	ItemResultList<Annotation> inheritedAnnotations = null;
	if (as != null)
	{
		ItemQuery<Annotation> inheritedQuery = as.getAllInheritedAnnotations();
		// Need FETCH JOIN because Postgres don't like the DISTINCT keyword
		// if we sort on a non-selected column See ticket #731
		inheritedQuery.join(Hql.innerJoin(null, "annotationType", "at", true));
		inheritedQuery.order(Orders.asc(Hql.property("annotationSet")));
		inheritedQuery.order(Orders.asc(Hql.property("at", "name")));
		inheritedAnnotations = inheritedQuery.list(dc);
	}
	%>
	<base:page type="include">
	<base:body>
		<script language="JavaScript">
		function editAnnotation(annotationTypeId)
		{
			var url = getRoot() + 'common/annotations/annotate.jsp?ID=<%=ID%>';
			url += '&item_type=<%=itemType.name()%>';
			url += '&item_id=<%=itemId%>';
			url += '&annotationtype_id='+annotationTypeId;
			url += '&standalone=1';
			Main.openPopup(url, 'EditAnnotation', 700, 460);
		}
		function editInheritedAnnotation(itemType, itemId, annotationTypeId)
		{
			var url = getRoot() + 'common/annotations/annotate.jsp?ID=<%=ID%>';
			url += '&item_type='+itemType;
			url += '&item_id='+itemId;
			url += '&annotationtype_id='+annotationTypeId;
			url += '&standalone=1';
			Main.openPopup(url, 'EditAnnotation', 700, 460);
		}
		</script>
			<%
			if (annotationTypes.size() == 0)
			{
				%>
				<h4>Primary annotations</h4>
				No annotation types has been defined for this type of item 
				(or you don't have permission to view them).
				<%
			}
			else
			{
				%>
				<%=message == null ? "" : message%>
				<h4 class="docked">Primary annotations</h4>
				<tbl:table
					id="annotations"
					clazz="itemlist"
					columns="all"
					>
					<tbl:columndef 
						id="annotation"
						title="Annotation"
					/>
					<tbl:columndef 
						id="values"
						title="Values"
					/>
					<tbl:columndef 
						id="description"
						title="Description"
					/>
					<tbl:data>
						<tbl:columns>
						</tbl:columns>
						<tbl:rows>
						<%
						for (AnnotationType at : annotationTypes)
						{
							Formatter formatter = FormatterFactory.getTypeFormatter(sc, at.getValueType());
							List<?> values = as == null || !as.hasAnnotation(at) ? 
								null : as.getAnnotation(at).getValues();
							if (values != null || !at.isRemoved())
							{
								%>
								<tbl:row>
									<tbl:cell column="annotation"><base:icon 
										image="deleted.gif" 
										tooltip="This item has been scheduled for deletion" 
										visible="<%=at.isRemoved()%>"
									/><%=Base.getLinkedName(ID, at, false, true)%></tbl:cell>
									<tbl:cell column="values"><%=values == null || values.size() == 0 ? "<i>- no values -</i>" : Values.getString(values, ", ", true, formatter)%>
									<%
										if (writePermission)
										{
											%>: <base:icon image="edit.gif" 
												onclick="<%="editAnnotation("+at.getId()+")"%>" 
												tooltip="Modify the values of this annotation" />
											<%
										}
										%>
									</tbl:cell>
									<tbl:cell column="description"><%=HTML.encodeTags(at.getDescription())%></tbl:cell>
								</tbl:row>
								<%
							}
						}
						%>
						</tbl:rows>
					</tbl:data>
				</tbl:table>
				<br>
				<%
			}
			%>

			<%
			if (protocolParameters != null )
			{
				if (protocolParameters.size() == 0)
				{
					%>
					<h4>Protocol parameters</h4>
					No protocol parameters has been defined for the protocol 
					<%=Base.getLinkedName(ID, protocol, !readProtocol, true)%> 
					(or you don't have permission to view them).
					<%
				}
				else
				{
					%>
					<h4 class="docked">Protocol parameters for: 
						<%=Base.getLinkedName(ID, protocol, !readProtocol, true)%></h4>
					<tbl:table
						id="parameters"
						clazz="itemlist"
						columns="all"
						>
						<tbl:columndef 
							id="parameter"
							title="Parameter"
						/>
						<tbl:columndef 
							id="values"
							title="Values"
						/>
						<tbl:columndef 
							id="description"
							title="Description"
						/>
						<tbl:data>
							<tbl:columns>
							</tbl:columns>
							<tbl:rows>
							<%
							for (AnnotationType at : protocolParameters)
							{
								Formatter formatter = FormatterFactory.getTypeFormatter(sc, at.getValueType());
								List<?> values = as == null || !as.hasAnnotation(at) ? 
									null : as.getAnnotation(at).getValues();
								if (values != null || !at.isRemoved())
								{
									%>
									<tbl:row>
										<tbl:cell column="parameter"><base:icon 
											image="deleted.gif" 
											tooltip="This item has been scheduled for deletion" 
											visible="<%=at.isRemoved()%>"
										/><%=Base.getLinkedName(ID, at, false, true)%></tbl:cell>
										<tbl:cell column="values">
											<%=values == null || values.size() == 0 ? "<i>- no values -</i>" : Values.getString(values, ", ", true, formatter)%>
											<%
											if (writePermission)
											{
												%>: <base:icon image="edit.gif" 
													onclick="<%="editAnnotation("+at.getId()+")"%>" 
													tooltip="Modify the values of this protocol parameter" />
												<%
											}
											%>
										</tbl:cell>
										<tbl:cell column="description"><%=HTML.encodeTags(at.getDescription())%></tbl:cell>
									</tbl:row>
									<%
								}
							}
							%>
							</tbl:rows>
						</tbl:data>
					</tbl:table>
					<br>
					<%
				}
			}
			%>

			<%
			if (!isProxy)
			{
			if (inheritedAnnotations == null || inheritedAnnotations.size() == 0)
			{
				%>
				<h4>Inherited annotations and protocol parameters</h4>
				No annotations are inherited by this item.
				<%
			}
			else
			{
				%>
				<h4 class="docked">Inherited annotations and protocol parameters</h4>
				<tbl:table
					id="inheritedAnnotations"
					clazz="itemlist"
					columns="all"
					>
					<tbl:columndef 
						id="annotation"
						title="Annotation"
					/>
					<tbl:columndef 
						id="item"
						title="From item"
					/>
					<tbl:columndef 
						id="values"
						title="Values"
					/>
					<tbl:columndef 
						id="description"
						title="Description"
					/>
					<tbl:data>
						<tbl:columns>
						</tbl:columns>
						<tbl:rows>
						<%
						String denied = "<i>- denied -</i>";
						for (Annotation a : inheritedAnnotations)
						{
							AnnotationType at = null;
							int annotationTypeId = 0;
							String name = denied;
							String description = "";
							boolean writeInherited = false;
							String icon = "joust/annotation.gif";
							Formatter formatter = FormatterFactory.getTypeFormatter(sc, a.getValueType());
							try
							{
								at = a.getAnnotationType();
								annotationTypeId = at.getId();
								name = HTML.encodeTags(at.getName());
								if (at.isRemoved())
								{
									icon = "deleted.gif";
								}
								else if (at.isProtocolParameter())
								{
									icon = "parameter.gif";
								}
								description = HTML.encodeTags(at.getDescription());
							}
							catch (PermissionDeniedException ex)
							{}
							Nameable aItem = null;
							try
							{
								aItem = (Nameable)a.getAnnotationSet().getItem();
								writeInherited = aItem.hasPermission(Permission.WRITE);
							}
							catch (PermissionDeniedException ex)
							{}
							List<?> values = a.getValues();
							%>
							<tbl:row>
								<tbl:cell column="annotation"><base:icon image="<%=icon%>" />&nbsp;<%=Base.getLinkedName(ID, at, at == null, true)%></tbl:cell>
								<tbl:cell column="item"><%=Base.getLinkedName(ID, aItem, aItem == null, true)%><%=aItem != null ? " ["+aItem.getType()+"]" : ""%></tbl:cell>
								<tbl:cell column="values">
									<%=values == null || values.size() == 0 ? 
										"<i>- no values -</i>" : Values.getString(values, ", ", true, formatter)%>
									<%
									if (writeInherited && aItem != null)
									{
										%>: <base:icon image="edit.gif" 
											onclick="<%="editInheritedAnnotation('"+aItem.getType().name()+"', "+aItem.getId()+", "+at.getId()+")"%>" 
											tooltip="Modify the values of this annotation" />
										<%
									}
									%>
								</tbl:cell>
								<tbl:cell column="description"><%=description%></tbl:cell>
							</tbl:row>
							<%
						}
						%>
						</tbl:rows>
					</tbl:data>
				</tbl:table>
				<base:icon image="joust/annotation.gif" /> = Annotation, 
				<base:icon image="parameter.gif" /> = Protocol parameter 
				<%
			}
			}
			%>

	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}

%>
