<%-- $Id: list_anytoany.jsp 4476 2008-09-05 15:14:42Z jari $
	------------------------------------------------------------------
	Copyright (C) 2006 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330,
	Boston, MA  02111-1307, USA.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.BasicItem"
	import="net.sf.basedb.core.AnyToAny"
	import="net.sf.basedb.core.Nameable"
	import="net.sf.basedb.core.File"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.ItemNotFoundException"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="java.util.List"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>

<%
String root = request.getContextPath() + "/";
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final Item itemType = Item.valueOf(request.getParameter("item_type"));
final int itemId = Values.getInt(request.getParameter("item_id"));
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();

try
{
	final BasicItem item = itemType.getById(dc, itemId);
	ItemQuery<AnyToAny> query = AnyToAny.getLinksFrom(item);
	query.order(Orders.asc(Hql.property("name")));
	ItemResultList<AnyToAny> links = query.list(dc);
	%>

	<base:page type="include">
	<base:head />
	<base:body>
	
		<%
		if (links.getTotalCount() == 0)
		{
			%>
			None.
			<%
		}
		else
		{
			%>
			<tbl:table
				id="links"
				clazz="itemlist"
				columns="all"
				>
				<tbl:columndef 
					id="name"
					title="Name"
				/>
				<tbl:columndef 
					id="item"
					title="Item"
				/>
				<tbl:columndef 
					id="description"
					title="Description"
				/>
				<tbl:data>
					<tbl:columns>
					</tbl:columns>
					<tbl:rows>
					<%
					for (AnyToAny ata : links)
					{
						String name = HTML.encodeTags(ata.getName());
						BasicItem to = null;
						boolean readTo = true;
						boolean missingTo = false;
						try
						{
							to = ata.getTo();
						}
						catch (PermissionDeniedException ex)
						{
							readTo = false;
						}
						catch (ItemNotFoundException ex)
						{
							missingTo = true;
						}
						
						String toLink = "";
						if (to instanceof File)
						{
							File toFile = (File)to;
							toLink = Base.getLinkedFile(ID, toFile, false, true, true, root);
						}
						else if (to instanceof Nameable)
						{
							Nameable nameable = (Nameable)to;
							toLink = Base.getLinkedName(ID, nameable, false, true);
						}
						else if (!readTo)
						{
							toLink = "<i>- denied -</i>";
						}
						else if (missingTo)
						{
							toLink = "<i>- missing -</i> (" + ata.getToType().toString() + "; id=" + ata.getToId() + ")";
						}
						else if (to == null)
						{
							toLink = "<i>- none -</i>";
						}
						else
						{
							toLink = Base.getLink(ID, to.toString(), to.getType(), to.getId(), true);
						}
						%>
						<tbl:row>
							<tbl:cell column="name"><%=Base.getLinkedName(ID, ata, false, true)%></tbl:cell>
							<tbl:cell column="item"><%=toLink%></tbl:cell>
							<tbl:cell column="description"><%=HTML.encodeTags(ata.getDescription())%></tbl:cell>
						</tbl:row>
						<%
					}
					%>
					</tbl:rows>
				</tbl:data>
			</tbl:table>
			<%
		}
		%>
		<br>

	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}

%>
