<%-- $Id: saveas.jsp 4506 2008-09-11 09:29:40Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Hakkinen, Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330,
	Boston, MA  02111-1307, USA.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final Item itemType = Item.valueOf(request.getParameter("item_type"));
final String subContext = request.getParameter("subcontext");
final ItemContext current = sc.getCurrentContext(itemType, subContext);
final String name = ItemContext.DEFAULT_NAME.equals(current.getName()) ? null : current.getName();
%>
<base:page type="popup" title="Save preset as...">
<base:head>
	<script language="JavaScript">
	// Initialise - set focus to name field
	function init()
	{
		var frm = document.forms["preset"];
		frm.name.focus();
	}

	// Validate the form
	function validateForm()
	{
		var frm = document.forms["preset"];
		if (Main.trimString(frm.name.value) == '')
		{
			frm.name.focus();
			alert("Please enter a name");
			return false;
		}
		return true;
	}

	// Submit the form
	function savePreset()
	{
		var frm = document.forms["preset"];
		if (validateForm())
		{
			frm.submit();
		}
	}
	</script>
</base:head>
<base:body onload="init()">
	<p>
	<form name="preset" action="index.jsp" method="post" onsubmit="return validateForm();">
	<input type=hidden name="ID" value="<%=ID%>">
	<input type=hidden name="cmd" value="SaveCurrentContext">
	<input type=hidden name="item_type" value="<%=itemType.name()%>">
	<input type=hidden name="subcontext" value="<%=subContext%>">

	<h3 class="docked">Save preset as... <base:help helpid="contexts.saveas" /></h3>
	<div class="boxed" align="center">
		<br>
		<table class="form" cellspacing=0>
		<tr>
			<td class="prompt">For item</td>
			<td><%=itemType%><%="".equals(subContext) ? "" : " ("+subContext+")"%></td>
		</tr>
		<tr>
			<td class="prompt">Name</td>
			<td><input class="text required" type="text" name="name" value="<%=HTML.encodeTags(name)%>" size="40" maxlength="40"></td>
		</tr>
		<tr>
			<td class="prompt">Overwrite existing</td>
			<td><input type="checkbox" name="overwrite" value="1" <%=name == null ? "" : "checked"%>></td>
		</tr>
		<%
		if (sc.hasSystemPermission(Permission.SHARE_TO_EVERYONE))
		{
			%>
			<tr>
				<td class="prompt">Public</td>
				<td><input type="checkbox" name="public" value="1"></td>
			</tr>
			<%
		}
		%>
		<tr>
			<td colspan="2">
			<div align=right>&nbsp;<i><base:icon image="required.gif" /> = required information</i></div>
			</td>
		</tr>
		</table>
		<p>
	</div>
	</form>

	<table align="center">
	<tr>
		<td width="50%"><base:button onclick="savePreset();" title="Ok" /></td>
		<td width="50%"><base:button onclick="window.close();" title="Cancel" /></td>
	</tr>
	</table>

</base:body>
</base:page>
